/*
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Switzerland License. To view a copy of this license, visit
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ch/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 */

package ch.njol.skript.api;

import java.util.regex.Matcher;

import org.bukkit.event.Event;

/**
 * A very basic SkriptEvent which returns true for all events (i.e. all registered events). This event is especially useful for custom events.
 * 
 * @author Peter Gttinger
 */
public class SimpleEvent extends SkriptEvent {
	
	public SimpleEvent() {}
	
	@Override
	public boolean check(final Event e) {
		return true;
	}
	
	@Override
	public void init(final Object[][] args, final int matchedPattern, final Matcher matcher) {}
	
	@Override
	public String getDebugMessage(final Event e) {
		return "simple event";
	}
	
}
