/*
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Switzerland License. To view a copy of this license, visit
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ch/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 */

package ch.njol.skript.loops;

import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;

import org.bukkit.event.Event;

import ch.njol.skript.Skript;
import ch.njol.skript.api.InitException;
import ch.njol.skript.api.LoopVar;
import ch.njol.skript.api.ParseException;
import ch.njol.skript.api.Variable;
import ch.njol.skript.util.ItemData;
import ch.njol.skript.util.ItemType;
import ch.njol.util.ArrayIterator;

/**
 * @author Peter Gttinger
 * 
 */
public class LoopVarIdsOf extends LoopVar<Integer> {
	
	static {
		Skript.addLoop(LoopVarIdsOf.class, Integer.class, "id", "ids of %itemtype%");
	}
	
	private Variable<ItemType> types;
	
	@SuppressWarnings("unchecked")
	@Override
	public void init(final List<Variable<?>> vars, final int matchedPattern, final Matcher matcher) throws InitException, ParseException {
		types = (Variable<ItemType>) vars.get(0);
	}
	
	@Override
	public String getDebugMessage(final Event e) {
		return "ids of " + types.getDebugMessage(e);
	}
	
	@Override
	protected Iterator<Integer> iterator(final Event e) {
		return new Iterator<Integer>() {
			
			private final Iterator<ItemType> ts = new ArrayIterator<ItemType>(types.get(e));
			private Iterator<ItemData> ds = ts.next().types.iterator();
			
			@Override
			public boolean hasNext() {
				while (ts.hasNext() && !ds.hasNext()) {
					ds = ts.next().types.iterator();
				}
				return ts.hasNext() || ds.hasNext();
			}
			
			@Override
			public Integer next() {
				return ds.next().typeid;
			}
			
			@Override
			public void remove() {}
			
		};
	}
	
	@Override
	public Class<? extends Integer> getReturnType() {
		return Integer.class;
	}
	
}
