/*
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Switzerland License. To view a copy of this license, visit
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ch/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 */

package ch.njol.skript.variables;

import java.util.List;
import java.util.regex.Matcher;

import org.bukkit.entity.Creature;
import org.bukkit.entity.Entity;
import org.bukkit.event.Event;

import ch.njol.skript.Skript;
import ch.njol.skript.api.InitException;
import ch.njol.skript.api.ParseException;
import ch.njol.skript.api.Variable;

/**
 * @author Peter Gttinger
 * 
 */
public class VarCreature extends Variable<Creature> {
	
	static {
		Skript.addVariable(VarCreature.class, Creature.class, "creature");
	}
	
	@Override
	public void init(final List<Variable<?>> vars, final int matchedPattern, final Matcher matcher) throws InitException, ParseException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public String getDebugMessage(final Event e) {
		if (e == null)
			return "creature";
		return Skript.toString(get(e)[0]);
	}
	
	@Override
	protected Creature[] getAll(final Event e) {
		final Entity ent = Skript.getEventValue(e, Entity.class);
		if (ent instanceof Creature)
			return new Creature[] {(Creature) ent};
		return null;
	}
	
	@Override
	public Class<? extends Creature> getReturnType() {
		return Creature.class;
	}
	
}
